#pragma once

#include "vamp-hostsdk/PluginWrapper.h"

namespace vamp::host
{
  class PluginChannelAdapter : public PluginWrapper
  {
    public:
      PluginChannelAdapter(plugin* p);
      virtual ~PluginChannelAdapter();

      bool initialise(size_t channels, size_t stepSize, size_t blockSize);

      FeatureSet process(const float *const *inputBuffers, real_time timestamp);
      FeatureSet processInterleaved(const float *inputBuffer, real_time timestamp);

    protected:
      class Impl;
      Impl* m_impl;
  };
}
